<?php

namespace GoalTrackerPatreon;

defined( 'ABSPATH' ) or die;

class Button_widget extends \WP_Widget {

	static $goals = array();

	const url_prompt = 'http://example.com/thankyou/';

	public function __construct() {
		parent::__construct(
			'GoalTrackerForPatreonButtonWidget',
			'Patreon Support Button',
			array( 'description' => __( 'Adds a Patreon button users can click to support you.', 'text_domain' ), )
		);
	}


	public function widget( $args, $instance ) {
		echo $args['before_widget'];
		if ( ! empty( $instance['title'] ) ) {
			echo $args['before_title'] . apply_filters( 'widget_title', $instance['title'] ). $args['after_title'];
		}

		$redirectURI = urlencode($instance['redirectURI']);
		$creatorId = get_option(Options::creator_id_option_name);

		echo '<div style="text-align: center;">';
		echo '<a href="https://www.patreon.com/bePatron?u='.$creatorId.'&amp;redirect_uri='.$redirectURI.'">';
        echo '<img height="40" width="204" src="https://s3-us-west-1.amazonaws.com/widget-images/become-patron-widget-medium%402x.png" scale="0">';
		echo '</a>';
		echo '</div>';

		echo $args['after_widget'];
	}

	public function form( $instance ) {
		$title = ! empty( $instance['title'] ) ? $instance['title'] : '';
		$pitch = ! empty( $instance['pitch'] ) ? $instance['pitch'] : '';
		$redirectURI = ! empty( $instance['redirectURI'] ) ? $instance['redirectURI'] : __( self::url_prompt, 'text_domain' );

		echo '<p>';
		echo '<label for="'.$this->get_field_id( 'title' ).'">'._e( 'Title:' ).'</label>';
		echo '<input class="widefat" id="'.$this->get_field_id( 'title' ).'" name="'.$this->get_field_name( 'title' ).'" type="text" value="'.esc_attr( $title ).'">';
		echo '</p>';

		echo '<p>';
		echo '<label for="'.$this->get_field_id( 'pitch' ).'">'._e( 'Pitch:' ).'</label>';
		echo '<textarea class="widefat" id="'.$this->get_field_id( 'pitch' ).'" name="'.$this->get_field_name( 'pitch' ).'">'.esc_attr( $pitch ).'</textarea>';
		echo '<br><span style="font-size: smaller;">A short blurb telling people why they should click the button. You can leave this blank if you want.</span>';
		echo '</p>';

		echo '<p>';
		echo '<label for="'.$this->get_field_id( 'redirectURI' ).'">'._e( 'Return URL:' ).'</label>';
		echo '<input class="widefat" id="'.$this->get_field_id( 'redirectURI' ).'" name="'.$this->get_field_name( 'redirectURI' ).'" type="text" value="'.esc_attr( $redirectURI ).'">';
		echo '<br><span style="font-size: smaller;">This is the url on your site users will return to. Maybe a page that says "Thank you!" would be nice.</span>';
		echo '</p>';
	}

	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
		$instance['pitch'] = ( ! empty( $new_instance['pitch'] ) ) ? strip_tags( $new_instance['pitch'] ) : '';
		$instance['redirectURI'] = ( ! empty( $new_instance['redirectURI'] ) &&  $new_instance['redirectURI'] != self::url_prompt) ? strip_tags( $new_instance['redirectURI'] ) : '';

		return $instance;
	}
}

